const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const shift_assignments = sequelize.define(
    'shift_assignments',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

assigned_from: {
        type: DataTypes.DATE,
      
      

      },

assigned_to: {
        type: DataTypes.DATE,
      
      

      },

status: {
        type: DataTypes.ENUM,
      
      

        values: [

"scheduled",


"completed",


"no_show",


"cancelled"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  shift_assignments.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























































//end loop



    db.shift_assignments.belongsTo(db.work_shifts, {
      as: 'work_shift',
      foreignKey: {
        name: 'work_shiftId',
      },
      constraints: false,
    });

    db.shift_assignments.belongsTo(db.employees, {
      as: 'employee',
      foreignKey: {
        name: 'employeeId',
      },
      constraints: false,
    });

    db.shift_assignments.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.shift_assignments.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.shift_assignments.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return shift_assignments;
};


